"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const url = __importStar(require("url"));
const is_relative_url_1 = __importDefault(require("is-relative-url"));
class BackgroundImage {
    constructor(style, root) {
        this.inputValue = [style, root];
    }
    get value() {
        const [style, root] = this.inputValue;
        return this.normalize([style, root]);
    }
    normalize([style, root]) {
        if (this.isEmpty(style)) {
            return null;
        }
        try {
            const base = new URL(root);
            const image = /(background-image:\s?url\((.*)?)\)/.exec(style);
            const match = image[2].replace(/'|"/g, '');
            if (is_relative_url_1.default(match)) {
                return url.resolve(base.origin, match);
            }
            return match;
        }
        catch (e) {
            return null;
        }
    }
    isEmpty(style) {
        return (style === undefined || style === null || style.trim().length === 0);
    }
}
exports.default = BackgroundImage;
